<?php
/*
Plugin Name: Connecteur Gestan
Plugin URI: http://wiki.gestan.fr/doku.php?id=wiki:addons:espace_client_wordpress
Description: Ce plugin permet la communication entre Wordpress et Gestan (<a href="http://www.gestan.fr" target="_blank">www.gestan.fr</a>) - logiciel édité par <a href="http://www.ics-informatique.com/" target="_blank">ICS-Informatique</a>
Version: 1.0
Author: Julian Siegwald
Author URI: http://www.lcpstudio.fr
Text Domain: Gestan
Domain Path: languages
*/
defined( 'ABSPATH' ) or die( 'Pas de scripts autorisés, merci !' );

define("ImgCheck", plugins_url('img/Check.png' , __FILE__ ));
define("ImgPaiement", plugins_url('img/Paiement.png' , __FILE__ ));

global $current_user;


function Creation_tables_Gestan()
{
    global $wpdb;

    $BDD_clients = $wpdb->prefix . 'GestanClients';

    $sql = "CREATE TABLE $BDD_clients (
	`ID_client` int(6) NULL,
	`IDTech` int(8) NOT NULL AUTO_INCREMENT,
	`Civilite` varchar(15) NULL,
	`Prenom` varchar(35) NULL,
	`Nom` varchar(35) NULL,
	`Adresse1` varchar(150) NULL,
	`Adresse2` varchar(150) NULL,
	`CP` varchar(7) NULL,
	`Ville` varchar(50) NULL,
	`Email` varchar(50) NULL,
	`TelHome` varchar(20) NULL,
	`TelGSM` varchar(20) NULL,
	`Date_Naissance` date NULL,
	UNIQUE KEY id (IDTech)
    );";

    $BDD_param = $wpdb->prefix . 'GestanParam';

    $sql.= "CREATE TABLE $BDD_param (
	`IDTech` int(2) NOT NULL AUTO_INCREMENT,
	`PaypalEmail` varchar(50) NULL,
	`PagePaiementOK` varchar(150) NULL,
	`PagePaiementKO` varchar(150) NULL,
	UNIQUE KEY id (IDTech)
    );";

    
    
    $BDD_factures = $wpdb->prefix . 'GestanFactures';

    $sql.= "CREATE TABLE $BDD_factures (
	`IDTech` int(8) NOT NULL AUTO_INCREMENT,
	`NomPrenom` varchar(45) NULL,
	`Num_Facture` varchar(15) NULL,
	`Date` date NULL,
	`Nature` varchar(150) NULL,
	`Total` float NULL,
	`ResteAPayer` float NULL,
	`Statut` varchar(25) NULL,
	`Email` varchar(35) NULL,
	`Telechargement` varchar(150) NULL,
	UNIQUE KEY id (IDTech)
    );";






    $BDD_devis = $wpdb->prefix . 'GestanDevis';
    $sql.= "CREATE TABLE $BDD_devis (
	`IDTech` int(8) NOT NULL AUTO_INCREMENT,
	`NomPrenom` varchar(45) NULL,
	`Num_Devis` varchar(15) NULL,
	`Date` date NULL,
	`Nature` varchar(150) NULL,
	`Total` float NULL,
	`ResteAPayer` float NULL,
	`Statut` varchar(25) NULL,
	`Email` varchar(35) NULL,
	`Telechargement` varchar(150) NULL,
	UNIQUE KEY id (IDTech)
    );";



    
    require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
    dbDelta( $sql ); 
}

register_activation_hook( __FILE__, 'Creation_tables_Gestan' );












// [Gestan_Coordonnees]
function Gt_Coordonnees() {

    global $wpdb;
    global $current_user;
    
    if ( is_user_logged_in() ) {
        $ReponseArray = $wpdb->get_results('SELECT * FROM `' . $wpdb->prefix . 'GestanClients` WHERE Email="'.$current_user->user_email.'"');

        $reponse = '';
        foreach ( (array) $ReponseArray as $ReponseUnique ) {       
          $reponse.='<b>';
          if(!empty($ReponseUnique->Civilite)) {$reponse.= $ReponseUnique->Civilite." ";}

          if(!empty($ReponseUnique->Prenom)) {$reponse.= $ReponseUnique->Prenom . " ";}
          if(!empty($ReponseUnique->Nom)) {$reponse.= $ReponseUnique->Nom;}
          $reponse.='</b><br />';
          if(!empty($ReponseUnique->Adresse1)) {$reponse.=$ReponseUnique->Adresse1."<br />";}
          if(!empty($ReponseUnique->Adresse2)) {$reponse.=$ReponseUnique->Adresse2."<br />";}
          if(!empty($ReponseUnique->CP)) {$reponse.=$ReponseUnique->CP." ";}
          if(!empty($ReponseUnique->Ville)) {$reponse.=$ReponseUnique->Ville;}
          $reponse.='<br /><em>';
          if(!empty($ReponseUnique->Email)) {$reponse.=("<a href='mailto:".$ReponseUnique->Email."'>".$ReponseUnique->Email."</a><br />");}
          $reponse.="</em><br />";
          if(!empty($ReponseUnique->TelHome)) {$reponse.=$ReponseUnique->TelHome."<br />";}
          if(!empty($ReponseUnique->TelGSM)) {$reponse.=$ReponseUnique->TelGSM."<br />";}
          if(!empty($ReponseUnique->Date_Naissance)) {$reponse.="Né(e) le: ".date("d/m/Y", strtotime($ReponseUnique->Date_Naissance))."<br />";} 
        }
    return $reponse;
    }
}

add_shortcode( 'Gestan_Coordonnees', 'Gt_Coordonnees' );


// [Gestan_Civilite]
function Gt_Civilite() {

    global $wpdb;
    global $current_user;
    
    if ( is_user_logged_in() ) {
        $ReponseArray = $wpdb->get_results('SELECT * FROM `' . $wpdb->prefix . 'GestanClients` WHERE Email="'.$current_user->user_email.'"');

        $reponse = '';
        foreach ( (array) $ReponseArray as $ReponseUnique ) {       
          if(!empty($ReponseUnique->Civilite)) {$reponse.= $ReponseUnique->Civilite." ";}
        }
    return $reponse;
    }
}

add_shortcode( 'Gestan_Civilite', 'Gt_Civilite' );



// [Gestan_Prenom]
function Gt_Prenom() {

    global $wpdb;
    global $current_user;
    
    if ( is_user_logged_in() ) {
        $ReponseArray = $wpdb->get_results('SELECT * FROM `' . $wpdb->prefix . 'GestanClients` WHERE Email="'.$current_user->user_email.'"');

        $reponse = '';
        foreach ( (array) $ReponseArray as $ReponseUnique ) {       
          if(!empty($ReponseUnique->Prenom)) {$reponse.= $ReponseUnique->Prenom . " ";}
        }
    return $reponse;
    }
}

add_shortcode( 'Gestan_Prenom', 'Gt_Prenom' );



// [Gestan_Nom]
function Gt_Nom() {

    global $wpdb;
    global $current_user;
    
    if ( is_user_logged_in() ) {
        $ReponseArray = $wpdb->get_results('SELECT * FROM `' . $wpdb->prefix . 'GestanClients` WHERE Email="'.$current_user->user_email.'"');

        $reponse = '';
        foreach ( (array) $ReponseArray as $ReponseUnique ) {       
          if(!empty($ReponseUnique->Nom)) {$reponse.= $ReponseUnique->Nom . " ";}
        }
    return $reponse;
    }
}

add_shortcode( 'Gestan_Nom', 'Gt_Nom' );


// [Gestan_Adresse1]
function Gt_Adresse1() {

    global $wpdb;
    global $current_user;
    
    if ( is_user_logged_in() ) {
        $ReponseArray = $wpdb->get_results('SELECT * FROM `' . $wpdb->prefix . 'GestanClients` WHERE Email="'.$current_user->user_email.'"');

        $reponse = '';
        foreach ( (array) $ReponseArray as $ReponseUnique ) {       
          if(!empty($ReponseUnique->Adresse1)) {$reponse.= $ReponseUnique->Adresse1 . " ";}
        }
    return $reponse;
    }
}

add_shortcode( 'Gestan_Adresse1', 'Gt_Adresse1' );


// [Gestan_Adresse2]
function Gt_Adresse2() {

    global $wpdb;
    global $current_user;
    
    if ( is_user_logged_in() ) {
        $ReponseArray = $wpdb->get_results('SELECT * FROM `' . $wpdb->prefix . 'GestanClients` WHERE Email="'.$current_user->user_email.'"');

        $reponse = '';
        foreach ( (array) $ReponseArray as $ReponseUnique ) {       
          if(!empty($ReponseUnique->Adresse2)) {$reponse.= $ReponseUnique->Adresse2 . " ";}
        }
    return $reponse;
    }
}

add_shortcode( 'Gestan_Adresse2', 'Gt_Adresse2' );



// [Gestan_CP]
function Gt_CP() {

    global $wpdb;
    global $current_user;
    
    if ( is_user_logged_in() ) {
        $ReponseArray = $wpdb->get_results('SELECT * FROM `' . $wpdb->prefix . 'GestanClients` WHERE Email="'.$current_user->user_email.'"');

        $reponse = '';
        foreach ( (array) $ReponseArray as $ReponseUnique ) {       
          if(!empty($ReponseUnique->CP)) {$reponse.= $ReponseUnique->CP . " ";}
        }
    return $reponse;
    }
}

add_shortcode( 'Gestan_CP', 'Gt_CP' );


// [Gestan_Ville]
function Gt_Ville() {

    global $wpdb;
    global $current_user;
    
    if ( is_user_logged_in() ) {
        $ReponseArray = $wpdb->get_results('SELECT * FROM `' . $wpdb->prefix . 'GestanClients` WHERE Email="'.$current_user->user_email.'"');

        $reponse = '';
        foreach ( (array) $ReponseArray as $ReponseUnique ) {       
          if(!empty($ReponseUnique->Ville)) {$reponse.= $ReponseUnique->Ville . " ";}
        }
    return $reponse;
    }
}

add_shortcode( 'Gestan_Ville', 'Gt_Ville' );



// [Gestan_Email]
function Gt_Email() {

    global $wpdb;
    global $current_user;
    
    if ( is_user_logged_in() ) {
        $ReponseArray = $wpdb->get_results('SELECT * FROM `' . $wpdb->prefix . 'GestanClients` WHERE Email="'.$current_user->user_email.'"');

        $reponse = '';
        foreach ( (array) $ReponseArray as $ReponseUnique ) {       
          if(!empty($ReponseUnique->Email)) {$reponse.=("<a href='mailto:".$ReponseUnique->Email."'>".$ReponseUnique->Email."</a><br />");}
        }
    return $reponse;
    }
}

add_shortcode( 'Gestan_Email', 'Gt_Email' );




// [Gestan_Telephone_Fixe]
function Gt_Telephone_Fixe() {

    global $wpdb;
    global $current_user;
    
    if ( is_user_logged_in() ) {
        $ReponseArray = $wpdb->get_results('SELECT * FROM `' . $wpdb->prefix . 'GestanClients` WHERE Email="'.$current_user->user_email.'"');

        $reponse = '';
        foreach ( (array) $ReponseArray as $ReponseUnique ) {       
          if(!empty($ReponseUnique->TelHome)) {$reponse.= $ReponseUnique->TelHome. " ";}
        }
    return $reponse;
    }
}

add_shortcode( 'Gestan_Telephone_Fixe', 'Gt_Telephone_Fixe' );




// [Gestan_Telephone_Portable]
function Gt_Telephone_Portable() {

    global $wpdb;
    global $current_user;
    
    if ( is_user_logged_in() ) {
        $ReponseArray = $wpdb->get_results('SELECT * FROM `' . $wpdb->prefix . 'GestanClients` WHERE Email="'.$current_user->user_email.'"');

        $reponse = '';
        foreach ( (array) $ReponseArray as $ReponseUnique ) {       
          if(!empty($ReponseUnique->TelGSM)) {$reponse.= $ReponseUnique->TelGSM. " ";}
        }
    return $reponse;
    }
}

add_shortcode( 'Gestan_Telephone_Portable', 'Gt_Telephone_Portable' );



// [Gestan_Date_Naissance]
function Gt_Date_Naissance() {

    global $wpdb;
    global $current_user;
    
    if ( is_user_logged_in() ) {
        $ReponseArray = $wpdb->get_results('SELECT * FROM `' . $wpdb->prefix . 'GestanClients` WHERE Email="'.$current_user->user_email.'"');

        $reponse = '';
        foreach ( (array) $ReponseArray as $ReponseUnique ) {       
          if(!empty($ReponseUnique->Date_Naissance)) {$reponse.="Né(e) le: ".date("d/m/Y", strtotime($ReponseUnique->Date_Naissance))."<br />";} 
        }
    return $reponse;
    }
}

add_shortcode( 'Gestan_Date_Naissance', 'Gt_Date_Naissance' );


// [Gestan_Factures] ou [Gestan_Factures telechargeable="faux"]
function Gt_Factures($atts) {

	if(empty($atts['telechargeable'])){$atts['telechargeable']="affichage";}
	
    global $wpdb;
    global $current_user;
    
	$ReponseArray2 = $wpdb->get_results('SELECT * FROM `' . $wpdb->prefix . 'GestanParam`');
	foreach ( (array) $ReponseArray2 as $ReponseUnique2 ) {
		if(!empty($ReponseUnique2->PaypalEmail)) {$EmailPaypal = $ReponseUnique2->PaypalEmail;};
		if(!empty($ReponseUnique2->PagePaiementOK)) {$PgOK = $ReponseUnique2->PagePaiementOK;};
		if(!empty($ReponseUnique2->PagePaiementKO)) {$PgKO = $ReponseUnique2->PagePaiementKO;};
	}
	
    if ( is_user_logged_in() ) {
        $ReponseArray = $wpdb->get_results('SELECT * FROM `' . $wpdb->prefix . 'GestanFactures` WHERE Email="'.$current_user->user_email.'" ORDER BY `Date` DESC');
        
		$reponse = '';
				
        foreach ( (array) $ReponseArray as $ReponseUnique ) {       
          
			$EnTete++;
			if($EnTete==1){
			if((empty($EmailPaypal)) || (empty($PgOK)) || (empty($PgKO))){
				$reponse.='<table class="Gestan"><tr><th class="Factures_Date">Date</th><th class="Factures_Numero">Numéro</th><th class="Factures_Libelle">Libellé</th><th class="Factures_Montant">Montant</th>';
			}else{
				$reponse.='<table class="Gestan"><tr><th class="Factures_Date">Date</th><th class="Factures_Numero">Numéro</th><th class="Factures_Libelle">Libellé</th><th class="Factures_Montant">Montant</th><th class="Factures_Statut">Statut</th>';
			}
					
				if($atts['telechargeable']!="faux"){
					$reponse.='<th class="Factures_Telechargement">Téléchargement</th>';
				}
				$reponse.='</tr>';
			}
			$reponse.="<tr>";
			$reponse.="<td class='Factures_Date'>".date("d/m/Y", strtotime($ReponseUnique->Date))."</td>";
			$reponse.="<td class='Factures_Numero'>".$ReponseUnique->Num_Facture."</td>";
			$reponse.="<td class='Factures_Libelle'>".$ReponseUnique->Nature."</td>";
			$reponse.="<td class='Factures_Montant'>".money_format("%.2n", $ReponseUnique->Total)."€</td>";
			
			if(($ReponseUnique->Statut==0)&&(!empty($EmailPaypal))&&(!empty($PgOK))&&(!empty($PgKO))){
				$reponse.="<td class='Factures_Statut'>";
				$reponse.='<form action="https://www.paypal.com/cgi-bin/webscr" id="paypal_form" method="post" target="_blank">';
				$reponse.='<input type="hidden" name="cmd" value="_xclick">';
				$reponse.='<input type="hidden" name="business" value="'.$EmailPaypal.'">';
				$reponse.='<input type="hidden" name="lc" value="FR">';
				$reponse.='<input type="hidden" name="currency_code" value="EUR">';
				$reponse.='<input type="hidden" name="button_subtype" value="services">';
				$reponse.='<input type="hidden" name="no_note" value="0">';
				$reponse.='<input type="hidden" name="no_shipping" value="2">';
				$reponse.='<input type="hidden" name="rm" value="1">';
				$reponse.='<input type="hidden" name="return" value="'.$PgOK.'">';
				$reponse.='<input type="hidden" name="cancel_return" value="'.$PgKO.'">';
				$reponse.='<input type="hidden" name="bn" value="PP-BuyNowBF:btn_buynowCC_LG.gif:NonHosted">';
				$reponse.='<input type="hidden" name="cn" value="'.$ReponseUnique->NomPrenom.'">';
				$reponse.='<input type="hidden" name="item_name" value="Facture '.$ReponseUnique->Num_Facture.'">';
				$reponse.='<input type="hidden" name="amount" value="'.$ReponseUnique->ResteAPayer.'">';
				$reponse.='<input type="image" src="'.ImgPaiement.'" alt="Payer">';
				$reponse.='</form>';
				$reponse.="</td>";
			}elseif($ReponseUnique->Statut==1){
				$reponse.="<td class='Factures_Statut'><img src='".ImgCheck."' alt='Facture réglée'/></td>";
			}else{
				$reponse.="<td class='Factures_Statut'><img src='".ImgPaiement."' alt='Facture réglée'/></td>";
			}
			
			if($atts['telechargeable']!="faux"){
				$reponse.="<td class='Factures_Telechargement'><a href=".$ReponseUnique->Telechargement." target='_BLANK'>Télécharger</a></td>";
			}
			
			$reponse.='</tr>';
			}
			
			$reponse.='</table>';


			if($EnTete==0){
				$reponse.="<h5>Aucune facture disponible avec l'adresse email '".$current_user->user_email."'</h5><br /><br /><br /><br />";
			}else{
				$reponse.='<div class="wpb_wrapper"><p style="text-align: left; font-size: small;"><em style="vertical-align: middle;"><img class="size-medium wp-image-3841 alignleft     lazyloaded" src="'.ImgPaiement.'" data-lazy-src="'.ImgPaiement.'" alt="Paiement" width="15" height="15"><noscript>&lt;img class="size-medium wp-image-3841 alignleft" src="'.ImgPaiement.'" alt="Paiement" width="15" height="15" /&gt;</noscript>Cette icone indique une facture qui n’est pas entièrement réglée. En cliquant dessus, vous serez redirigé vers Paypal (où vous pouvez également payer via CB)</em></p><p style="text-align: left; font-size: small;"><em style="vertical-align: middle;"><img class="size-full wp-image-3840 alignleft     lazyloaded" src="'.ImgCheck.'" data-lazy-src="'.ImgCheck.'" alt="Check" width="15" height="15"><noscript>&lt;img class="size-full wp-image-3840 alignleft" src="'.ImgCheck.'" alt="Check" width="15" height="15" /&gt;</noscript>Cette icone indique que la facture est réglée. Merci !</em></p></div>';
			}
  
 


       return $reponse;
    }
}

add_shortcode( 'Gestan_Factures', 'Gt_Factures' );









// [Gestan_Devis] ou [Gestan_Devis telechargeable="faux"]
function Gt_Devis($atts) {

	if(empty($atts['telechargeable'])){$atts['telechargeable']="affichage";}
	
    global $wpdb;
    global $current_user;
    
    if ( is_user_logged_in() ) {
    $ReponseArray = $wpdb->get_results('SELECT * FROM `' . $wpdb->prefix . 'GestanDevis` WHERE Email="'.$current_user->user_email.'" ORDER BY `Date` DESC');

        $reponse = '';
        foreach ( (array) $ReponseArray as $ReponseUnique ) {       
          
			$EnTete++;
			if($EnTete==1){
				$reponse.='<table class="Gestan"><tr class="Devis_Date"><th>Date</th><th class="Devis_Numero">Numéro</th><th class="Devis_Libelle">Libellé</th><th class="Devis_Montant">Montant</th>';
					
				if($atts['telechargeable']!="faux"){
					$reponse.='<th class="Devis_Telechargement">Téléchargement</th>';
				}
				

				$reponse.='</tr>';
			}
			$reponse.="<tr>";
			$reponse.="<td class='Devis_Date'>".date("d/m/Y", strtotime($ReponseUnique->Date))."</td>";
			$reponse.="<td class='Devis_Numero'>".$ReponseUnique->Num_Devis."</td>";
			$reponse.="<td class='Devis_Libelle'>".$ReponseUnique->Nature."</td>";
			$reponse.="<td class='Devis_Montant'>".money_format("%.2n", $ReponseUnique->Total)."€</td>";
			
			if($atts['telechargeable']!="faux"){
				$reponse.="<td class='Devis_Telechargement'><a href=".$ReponseUnique->Telechargement." target='_BLANK'>Télécharger</a></td>";
			}
			
			$reponse.='</tr>';
		}
			
			$reponse.='</table>';


			if($EnTete==0){
				$reponse.="<h5>Aucun devis disponible avec l'adresse email '".$current_user->user_email."'</h5><br /><br /><br /><br />";
			}


       return $reponse;
    }
}

add_shortcode( 'Gestan_Devis', 'Gt_Devis' );
